<template>
    <div :class="{ 'yt-editor': true, 'disabled': disabled }">
        <template v-if="disabled">
            <a :href="currentValue" target="_blank"><div class="link word_break">{{value}}</div></a>&nbsp;&nbsp;
        </template>
        <el-input v-else v-model="currentValue" :style="inputStyle"></el-input>

        <el-button v-if="currentValue" type="success" @click="playVideoHandler">{{btnText}}<i class="el-icon-caret-right"></i></el-button>
        <el-dialog v-if="dialogVisible" :title="popupTitle" :visible="dialogVisible" @close="stopPlayVideo">
            <you-tube-player :url="currentValue" />
        </el-dialog>
    </div>
</template>

<script>
import { YouTubePlayer } from '@/components/MediaViewer';

export default {
    components: {
        YouTubePlayer,
    },
    props: {
        /** URL value */
        value: {
            type: String,
            required: false,
        },
        /** css style of input control */
        inputStyle: {
            type: Object,
            required: false,
        },
        /** popup title */
        popupTitle: {
            type: String,
            required: false,
            default: 'Youtube Video',
        },
        /** text for button */
        btnText: {
            type: String,
            required: false,
            default: 'Play',
        },
        /** flag for disabling url's editing */
        disabled: {
            type: Boolean,
            required: false,
            default: false,
        },
    },
    data() {
        return {
            dialogVisible: false,
        };
    },
    computed: {
        currentValue: {
            get() {
                return this.value;
            },
            set(newVal) {
                this.$emit('input', newVal);
            },
        },
    },
    methods: {
        /** Show popup with video player */
        playVideoHandler() {
            this.dialogVisible = true;
        },
        /** Handler on closing popup with video player */
        stopPlayVideo() {
            this.$store.commit('destroyYTPlayer');
            this.dialogVisible = false;
        },
    },
};
</script>

<style lang="stylus" scoped>
.yt-editor
    display: flex
    align-items: center
    max-width: 90%
    margin-top: -1rem

.yt-editor > *
    margin-top: 1rem

.disabled
    flex-wrap: wrap
    max-width: 100%

.el-button
    width: 8rem

>>> .el-dialog
    width: 68rem
    border-radius: 1.4rem

>>> .el-dialog__body
    padding: 0rem 2rem 2rem

</style>
